xref: /titanic_51/usr/src/cmd/svc/milestone/net-physical (revision 1cfa752f4e24c34133009b0f6c139127a5c461de)
17c478bd9Sstevel@tonic-gate#!/sbin/sh
27c478bd9Sstevel@tonic-gate#
37c478bd9Sstevel@tonic-gate# CDDL HEADER START
47c478bd9Sstevel@tonic-gate#
57c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
66927f468Sdp# Common Development and Distribution License (the "License").
76927f468Sdp# You may not use this file except in compliance with the License.
87c478bd9Sstevel@tonic-gate#
97c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
107c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
117c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
127c478bd9Sstevel@tonic-gate# and limitations under the License.
137c478bd9Sstevel@tonic-gate#
147c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
157c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
167c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
177c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
187c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
197c478bd9Sstevel@tonic-gate#
207c478bd9Sstevel@tonic-gate# CDDL HEADER END
217c478bd9Sstevel@tonic-gate#
227c478bd9Sstevel@tonic-gate#
23*1cfa752fSRamaswamy Tummala# Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
247c478bd9Sstevel@tonic-gate#
257c478bd9Sstevel@tonic-gate# Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T.
267c478bd9Sstevel@tonic-gate# All rights reserved.
277c478bd9Sstevel@tonic-gate#
287c478bd9Sstevel@tonic-gate
296927f468Sdp. /lib/svc/share/smf_include.sh
306927f468Sdp. /lib/svc/share/net_include.sh
316927f468Sdp
327c478bd9Sstevel@tonic-gate#
33f4b3ec61Sdh155122# In a shared-IP zone we need this service to be up, but all of the work
347c478bd9Sstevel@tonic-gate# it tries to do is irrelevant (and will actually lead to the service
357c478bd9Sstevel@tonic-gate# failing if we try to do it), so just bail out.
36f4b3ec61Sdh155122# In the global zone and exclusive-IP zones we proceed.
377c478bd9Sstevel@tonic-gate#
38f4b3ec61Sdh155122smf_configure_ip || exit $SMF_EXIT_OK
397c478bd9Sstevel@tonic-gate
406e91bba0SGirish Moodalbail
417c478bd9Sstevel@tonic-gate# Make sure that the libraries essential to this stage of booting can be found.
427c478bd9Sstevel@tonic-gateLD_LIBRARY_PATH=/lib; export LD_LIBRARY_PATH
437c478bd9Sstevel@tonic-gate
447c478bd9Sstevel@tonic-gatesmf_netstrategy
457c478bd9Sstevel@tonic-gate
46f4b3ec61Sdh155122if smf_is_globalzone; then
47d62bc4baSyz147064	net_reconfigure || exit $SMF_EXIT_ERR_CONFIG
48d62bc4baSyz147064
494eaa4710SRishi Srivatsavai	# Update PVID on interfaces configured with VLAN 1
504eaa4710SRishi Srivatsavai	update_pvid
514eaa4710SRishi Srivatsavai
52d62bc4baSyz147064	#
53d62bc4baSyz147064	# Upgrade handling. The upgrade file consists of a series of dladm(1M)
54d62bc4baSyz147064	# commands. Note that after we are done, we cannot rename the upgrade
55d62bc4baSyz147064	# script file as the file system is still read-only at this point.
56d62bc4baSyz147064	# Defer this to the manifest-import service.
57d62bc4baSyz147064	#
58d62bc4baSyz147064	upgrade_script=/var/svc/profile/upgrade_datalink
59d62bc4baSyz147064	if [ -f "${upgrade_script}" ]; then
60d62bc4baSyz147064		. "${upgrade_script}"
61d62bc4baSyz147064	fi
62d62bc4baSyz147064
637c478bd9Sstevel@tonic-gate	#
64*1cfa752fSRamaswamy Tummala	# Upgrade handling for ibd:
65*1cfa752fSRamaswamy Tummala	# After we are done with the upgrade handling, we can not set the
66*1cfa752fSRamaswamy Tummala	# ibd/ibd_upgraded property to "true" as the file system is
67*1cfa752fSRamaswamy Tummala	# read-only at this point. It will be done later by ibd-post-upgrade
68*1cfa752fSRamaswamy Tummala	# service.
69*1cfa752fSRamaswamy Tummala	#
70*1cfa752fSRamaswamy Tummala	ibd_upgraded=`/bin/svcprop -c -p ibd/ibd_upgraded \
71*1cfa752fSRamaswamy Tummala	    $SMF_FMRI 2> /dev/null`
72*1cfa752fSRamaswamy Tummala	if [ "$ibd_upgraded" != "true" ]; then
73*1cfa752fSRamaswamy Tummala		/sbin/ibd_upgrade -v
74*1cfa752fSRamaswamy Tummala	fi
75*1cfa752fSRamaswamy Tummala
76*1cfa752fSRamaswamy Tummala	#
77b509e89bSRishi Srivatsavai	# Bring up simnets, link aggregations and initialize security objects.
780ba2cbe9Sxc151355	# Note that link property initialization is deferred until after
790ba2cbe9Sxc151355	# IP interfaces are plumbed to ensure that the links will not
80b509e89bSRishi Srivatsavai	# be unloaded (and the property settings lost). We should bring
81b509e89bSRishi Srivatsavai	# up simnets prior to VLANs/Aggrs to enable creation of VLANs/Aggrs
82b509e89bSRishi Srivatsavai	# over simnets.
83210db224Sericheng	#
84b509e89bSRishi Srivatsavai	/sbin/dladm up-simnet
85210db224Sericheng	/sbin/dladm up-aggr
86d62bc4baSyz147064	/sbin/dladm up-vlan
87*1cfa752fSRamaswamy Tummala	/sbin/dladm up-part
880ba2cbe9Sxc151355	/sbin/dladm init-secobj
89da14cebeSEric Cheng	#
90da14cebeSEric Cheng	# Bring up VNICs
91da14cebeSEric Cheng	#
92da14cebeSEric Cheng	/sbin/dladm up-vnic
93da14cebeSEric Cheng	#
94da14cebeSEric Cheng	# Create flows via flowadm.
95da14cebeSEric Cheng	#
96da14cebeSEric Cheng	/sbin/flowadm init-flow
97f4b3ec61Sdh155122fi
98210db224Sericheng
99210db224Sericheng#
1007c478bd9Sstevel@tonic-gate# If the system was net booted by DHCP, hand DHCP management off to the
1017c478bd9Sstevel@tonic-gate# DHCP agent (ifconfig communicates to the DHCP agent through the
1027c478bd9Sstevel@tonic-gate# loopback interface).
1037c478bd9Sstevel@tonic-gate#
1047c478bd9Sstevel@tonic-gateif [ -n "$_INIT_NET_IF" -a "$_INIT_NET_STRATEGY" = "dhcp" ]; then
1057c478bd9Sstevel@tonic-gate	/sbin/dhcpagent -a
1067c478bd9Sstevel@tonic-gatefi
1077c478bd9Sstevel@tonic-gate
1087c478bd9Sstevel@tonic-gate#
1097c478bd9Sstevel@tonic-gate# The network initialization is done early to support diskless and
1107c478bd9Sstevel@tonic-gate# dataless configurations.  For IPv4 interfaces that were configured by
1117c478bd9Sstevel@tonic-gate# the kernel (e.g.  those on diskless machines) and not configured by
1127c478bd9Sstevel@tonic-gate# DHCP, reset the netmask using the local "/etc/netmasks" file if one
1137c478bd9Sstevel@tonic-gate# exists, and then reset the broadcast address based on the netmask.
1147c478bd9Sstevel@tonic-gate#
1157c478bd9Sstevel@tonic-gate/sbin/ifconfig -auD4 netmask + broadcast +
1167c478bd9Sstevel@tonic-gate
1172b24ab6bSSebastien Royis_iptun ()
1182b24ab6bSSebastien Roy{
1192b24ab6bSSebastien Roy	intf=$1
1202b24ab6bSSebastien Roy	# Is this a persistent IP tunnel link?
1212b24ab6bSSebastien Roy	/sbin/dladm show-iptun -P $intf > /dev/null 2>&1
1222b24ab6bSSebastien Roy	if [ $? -eq 0 ]; then
1232b24ab6bSSebastien Roy		return 0
1242b24ab6bSSebastien Roy	fi
1252b24ab6bSSebastien Roy	# Is this an implicit IP tunnel (i.e., ip.tun0)
1262b24ab6bSSebastien Roy	ORIGIFS="$IFS"
1272b24ab6bSSebastien Roy	IFS="$IFS."
1282b24ab6bSSebastien Roy	set -- $intf
1292b24ab6bSSebastien Roy	IFS="$ORIGIFS"
1302b24ab6bSSebastien Roy	if [ $# -eq 2 -a \( "$1" = "ip" -o "$1" = "ip6" \) ]; then
1312b24ab6bSSebastien Roy		#
1322b24ab6bSSebastien Roy		# It looks like one, but another type of link might be
1332b24ab6bSSebastien Roy		# using a name that looks like an implicit IP tunnel.
1342b24ab6bSSebastien Roy		# If dladm show-link -P finds it, then it's not an IP
1352b24ab6bSSebastien Roy		# tunnel.
1362b24ab6bSSebastien Roy		#
1372b24ab6bSSebastien Roy		/sbin/dladm show-link -Pp $intf > /dev/null 2>&1
1382b24ab6bSSebastien Roy		if [ $? -eq 0 ]; then
1392b24ab6bSSebastien Roy			return 1
1402b24ab6bSSebastien Roy		else
1412b24ab6bSSebastien Roy			return 0
1422b24ab6bSSebastien Roy		fi
1432b24ab6bSSebastien Roy	fi
1442b24ab6bSSebastien Roy	return 1
1452b24ab6bSSebastien Roy}
1462b24ab6bSSebastien Roy
1477c478bd9Sstevel@tonic-gate#
1487c478bd9Sstevel@tonic-gate# All the IPv4 and IPv6 interfaces are plumbed before doing any
1497c478bd9Sstevel@tonic-gate# interface configuration.  This prevents errors from plumb failures
1507c478bd9Sstevel@tonic-gate# getting mixed in with the configured interface lists that the script
1517c478bd9Sstevel@tonic-gate# outputs.
1527c478bd9Sstevel@tonic-gate#
1537c478bd9Sstevel@tonic-gate
1547c478bd9Sstevel@tonic-gate#
1556e91bba0SGirish Moodalbail# First deal with /etc/hostname
1566e91bba0SGirish Moodalbail#
1577c478bd9Sstevel@tonic-gate# Get the list of IPv4 interfaces to configure by breaking
1587c478bd9Sstevel@tonic-gate# /etc/hostname.* into separate args by using "." as a shell separator
1597c478bd9Sstevel@tonic-gate# character.
1607c478bd9Sstevel@tonic-gate#
1617c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname.*[0-9] 2>/dev/null`"
1627c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname.*[0-9]" ]; then
1637c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1647c478bd9Sstevel@tonic-gate	IFS="$IFS."
1657c478bd9Sstevel@tonic-gate	set -- $interface_names
1667c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1677c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1687c478bd9Sstevel@tonic-gate		shift
169e11c3f44Smeem		intf_name=$1
170e11c3f44Smeem		while [ $# -gt 1 -a "$2" != "/etc/hostname" ]; do
171e11c3f44Smeem			intf_name="$intf_name.$2"
1727c478bd9Sstevel@tonic-gate			shift
1737c478bd9Sstevel@tonic-gate		done
1747c478bd9Sstevel@tonic-gate		shift
175e11c3f44Smeem
1762b24ab6bSSebastien Roy		# skip IP tunnel interfaces plumbed by net-iptun.
1772b24ab6bSSebastien Roy		if is_iptun $intf_name; then
1782b24ab6bSSebastien Roy			continue
1792b24ab6bSSebastien Roy		fi
1802b24ab6bSSebastien Roy
181e11c3f44Smeem	        read one rest < /etc/hostname.$intf_name
182e11c3f44Smeem		if [ "$one" = ipmp ]; then
183e11c3f44Smeem			ipmp_list="$ipmp_list $intf_name"
184e11c3f44Smeem		else
185e11c3f44Smeem			inet_list="$inet_list $intf_name"
1867c478bd9Sstevel@tonic-gate		fi
1877c478bd9Sstevel@tonic-gate	done
1887c478bd9Sstevel@tonic-gatefi
1897c478bd9Sstevel@tonic-gate
1907c478bd9Sstevel@tonic-gate#
1917c478bd9Sstevel@tonic-gate# Get the list of IPv6 interfaces to configure by breaking
1927c478bd9Sstevel@tonic-gate# /etc/hostname6.* into separate args by using "." as a shell separator
1937c478bd9Sstevel@tonic-gate# character.
1947c478bd9Sstevel@tonic-gate#
1957c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname6.*[0-9] 2>/dev/null`"
1967c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname6.*[0-9]" ]; then
1977c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1987c478bd9Sstevel@tonic-gate	IFS="$IFS."
1997c478bd9Sstevel@tonic-gate	set -- $interface_names
2007c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
2017c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
2027c478bd9Sstevel@tonic-gate		shift
203e11c3f44Smeem		intf_name=$1
204e11c3f44Smeem		while [ $# -gt 1 -a "$2" != "/etc/hostname6" ]; do
205e11c3f44Smeem			intf_name="$intf_name.$2"
2067c478bd9Sstevel@tonic-gate			shift
2077c478bd9Sstevel@tonic-gate		done
2087c478bd9Sstevel@tonic-gate		shift
209e11c3f44Smeem
2102b24ab6bSSebastien Roy		# skip IP tunnel interfaces plumbed by net-iptun.
2112b24ab6bSSebastien Roy		if is_iptun $intf_name; then
2122b24ab6bSSebastien Roy			continue
2132b24ab6bSSebastien Roy		fi
2142b24ab6bSSebastien Roy
215e11c3f44Smeem	        read one rest < /etc/hostname6.$intf_name
216e11c3f44Smeem		if [ "$one" = ipmp ]; then
217e11c3f44Smeem			ipmp6_list="$ipmp6_list $intf_name"
218e11c3f44Smeem		else
219e11c3f44Smeem			inet6_list="$inet6_list $intf_name"
2207c478bd9Sstevel@tonic-gate		fi
2217c478bd9Sstevel@tonic-gate	done
2227c478bd9Sstevel@tonic-gatefi
2237c478bd9Sstevel@tonic-gate
224e11c3f44Smeem#
225e11c3f44Smeem# Create all of the IPv4 IPMP interfaces.
226e11c3f44Smeem#
227e11c3f44Smeemif [ -n "$ipmp_list" ]; then
228e11c3f44Smeem	set -- $ipmp_list
229e11c3f44Smeem	while [ $# -gt 0 ]; do
230e11c3f44Smeem	    	if /sbin/ifconfig $1 ipmp; then
231e11c3f44Smeem			ipmp_created="$ipmp_created $1"
232e11c3f44Smeem		else
233e11c3f44Smeem			ipmp_failed="$ipmp_failed $1"
234e11c3f44Smeem		fi
235e11c3f44Smeem		shift
236e11c3f44Smeem	done
237e11c3f44Smeem	[ -n "$ipmp_failed" ] && warn_failed_ifs "create IPv4 IPMP" \
238e11c3f44Smeem	    "$ipmp_failed"
239e11c3f44Smeemfi
2407c478bd9Sstevel@tonic-gate
2417c478bd9Sstevel@tonic-gate#
2427c478bd9Sstevel@tonic-gate# Step through the IPv4 interface list and try to plumb every interface.
2437c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv4 interfaces.
2447c478bd9Sstevel@tonic-gate#
2457c478bd9Sstevel@tonic-gateif [ -n "$inet_list" ]; then
2467c478bd9Sstevel@tonic-gate	set -- $inet_list
2477c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2487c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 plumb
2497c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet >/dev/null 2>&1; then
2507c478bd9Sstevel@tonic-gate			inet_plumbed="$inet_plumbed $1"
2517c478bd9Sstevel@tonic-gate		else
2527c478bd9Sstevel@tonic-gate			inet_failed="$inet_failed $1"
2537c478bd9Sstevel@tonic-gate		fi
2547c478bd9Sstevel@tonic-gate		shift
2557c478bd9Sstevel@tonic-gate	done
256e11c3f44Smeem	[ -n "$inet_failed" ] && warn_failed_ifs "plumb IPv4" "$inet_failed"
2577c478bd9Sstevel@tonic-gatefi
2587c478bd9Sstevel@tonic-gate
259516fc7f3Shx147065# Run autoconf to connect to a WLAN if the interface is a wireless one
260516fc7f3Shx147065if [ -x /sbin/wificonfig -a -n "$inet_plumbed" ]; then
261516fc7f3Shx147065	set -- $inet_plumbed
262516fc7f3Shx147065	while [ $# -gt 0 ]; do
263516fc7f3Shx147065			if [ -r /dev/wifi/$1 ]; then
264516fc7f3Shx147065				/sbin/wificonfig -i $1 startconf >/dev/null
265516fc7f3Shx147065			fi
266516fc7f3Shx147065		shift
267516fc7f3Shx147065	done
268516fc7f3Shx147065fi
269516fc7f3Shx147065
2707c478bd9Sstevel@tonic-gate#
2717c478bd9Sstevel@tonic-gate# Step through the IPv6 interface list and plumb every interface.
2727c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv6 interfaces.  Each plumbed
2737c478bd9Sstevel@tonic-gate# interface will be brought up later, after processing any contents of
2747c478bd9Sstevel@tonic-gate# the /etc/hostname6.* file.
2757c478bd9Sstevel@tonic-gate#
2767c478bd9Sstevel@tonic-gateif [ -n "$inet6_list" ]; then
2777c478bd9Sstevel@tonic-gate	set -- $inet6_list
2787c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2797c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 inet6 plumb
2807c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet6 >/dev/null 2>&1; then
2817c478bd9Sstevel@tonic-gate			inet6_plumbed="$inet6_plumbed $1"
2827c478bd9Sstevel@tonic-gate		else
2837c478bd9Sstevel@tonic-gate			inet6_failed="$inet6_failed $1"
2847c478bd9Sstevel@tonic-gate		fi
2857c478bd9Sstevel@tonic-gate		shift
2867c478bd9Sstevel@tonic-gate	done
287e11c3f44Smeem	[ -n "$inet6_failed" ] && warn_failed_ifs "plumb IPv6" "$inet6_failed"
288e11c3f44Smeemfi
289e11c3f44Smeem
290e11c3f44Smeem#
291e11c3f44Smeem# Create all of the IPv6 IPMP interfaces.
292e11c3f44Smeem#
293e11c3f44Smeemif [ -n "$ipmp6_list" ]; then
294e11c3f44Smeem	set -- $ipmp6_list
295e11c3f44Smeem	while [ $# -gt 0 ]; do
296e11c3f44Smeem	    	if /sbin/ifconfig $1 inet6 ipmp; then
297e11c3f44Smeem			ipmp6_created="$ipmp6_created $1"
298e11c3f44Smeem		else
299e11c3f44Smeem			ipmp6_failed="$ipmp6_failed $1"
300e11c3f44Smeem 		fi
301e11c3f44Smeem		shift
302e11c3f44Smeem	done
303e11c3f44Smeem	[ -n "$ipmp6_failed" ] && warn_failed_ifs "create IPv6 IPMP" \
304e11c3f44Smeem	    "$ipmp6_failed"
3057c478bd9Sstevel@tonic-gatefi
3067c478bd9Sstevel@tonic-gate
3070ba2cbe9Sxc151355#
3086e91bba0SGirish Moodalbail# Finally configure interfaces set up with ipadm.
3096e91bba0SGirish Moodalbail#
3106e91bba0SGirish Moodalbailfor showif_output in `/sbin/ipadm show-if -p -o ifname,state`; do
3116e91bba0SGirish Moodalbail	intf=`echo $showif_output | /usr/bin/cut -f1 -d:`
3126e91bba0SGirish Moodalbail	state=`echo $showif_output | /usr/bin/cut -f2 -d:`
3136e91bba0SGirish Moodalbail	if  [ "$state" != "disabled" ]; then
3146e91bba0SGirish Moodalbail		# skip if not a persistent interface
3156e91bba0SGirish Moodalbail		continue;
3166e91bba0SGirish Moodalbail	elif is_iptun $intf; then
3176e91bba0SGirish Moodalbail		# skip IP tunnel interfaces plumbed by net-iptun
3186e91bba0SGirish Moodalbail		continue;
3196e91bba0SGirish Moodalbail	elif [ -f /etc/hostname.$intf ] || [ -f /etc/hostname6.$intf ]; then
3206e91bba0SGirish Moodalbail		echo "found /etc/hostname.$intf or /etc/hostname6.$intf, "\
3216e91bba0SGirish Moodalbail		    "ignoring ipadm configuration" > /dev/msglog
3226e91bba0SGirish Moodalbail		continue;
3236e91bba0SGirish Moodalbail	fi
3246e91bba0SGirish Moodalbail
3256e91bba0SGirish Moodalbail	# Enable the interface managed by ipadm
3266e91bba0SGirish Moodalbail	/sbin/ipadm enable-if -t $intf
3276e91bba0SGirish Moodalbaildone
3286e91bba0SGirish Moodalbail
3296e91bba0SGirish Moodalbail#
330e11c3f44Smeem# Process the /etc/hostname[6].* files for IPMP interfaces.  Processing these
331e11c3f44Smeem# before non-IPMP interfaces avoids accidental implicit IPMP group creation.
3327c478bd9Sstevel@tonic-gate#
333e11c3f44Smeem[ -n "$ipmp_created" ] && if_configure inet "IPMP" $ipmp_created
334e11c3f44Smeem[ -n "$ipmp6_created" ] && if_configure inet6 "IPMP" $ipmp6_created
3357c478bd9Sstevel@tonic-gate
3367c478bd9Sstevel@tonic-gate#
337e11c3f44Smeem# Process the /etc/hostname[6].* files for non-IPMP interfaces.
3387c478bd9Sstevel@tonic-gate#
339e11c3f44Smeem[ -n "$inet_plumbed" ] && if_configure inet "" $inet_plumbed
340e11c3f44Smeem[ -n "$inet6_plumbed" ] && if_configure inet6 "" $inet6_plumbed
341e11c3f44Smeem
342e11c3f44Smeem#
343e11c3f44Smeem# For the IPv4 and IPv6 interfaces that failed to plumb, find (or create)
344e11c3f44Smeem# IPMP meta-interfaces to host their data addresses.
345e11c3f44Smeem#
346e11c3f44Smeem[ -n "$inet_failed" ] && move_addresses inet
347e11c3f44Smeem[ -n "$inet6_failed" ] && move_addresses inet6
3487c478bd9Sstevel@tonic-gate
3497c478bd9Sstevel@tonic-gate# Run DHCP if requested. Skip boot-configured interface.
3507c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/dhcp.*[0-9] 2>/dev/null`"
3517c478bd9Sstevel@tonic-gateif [ "$interface_names" != '/etc/dhcp.*[0-9]' ]; then
3527c478bd9Sstevel@tonic-gate	#
3537c478bd9Sstevel@tonic-gate	# First find the primary interface. Default to the first
3547c478bd9Sstevel@tonic-gate	# interface if not specified. First primary interface found
3557c478bd9Sstevel@tonic-gate	# "wins". Use care not to "reconfigure" a net-booted interface
3567c478bd9Sstevel@tonic-gate	# configured using DHCP. Run through the list of interfaces
3577c478bd9Sstevel@tonic-gate	# again, this time trying DHCP.
3587c478bd9Sstevel@tonic-gate	#
3597c478bd9Sstevel@tonic-gate	i4d_fail=
3607c478bd9Sstevel@tonic-gate	firstif=
3617c478bd9Sstevel@tonic-gate	primary=
3627c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
3637c478bd9Sstevel@tonic-gate	IFS="${IFS}."
3647c478bd9Sstevel@tonic-gate	set -- $interface_names
3657c478bd9Sstevel@tonic-gate
3667c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
3677c478bd9Sstevel@tonic-gate		shift
3687c478bd9Sstevel@tonic-gate		[ -z "$firstif" ] && firstif=$1
3697c478bd9Sstevel@tonic-gate
3707c478bd9Sstevel@tonic-gate		for i in `shcat /etc/dhcp\.$1`; do
3717c478bd9Sstevel@tonic-gate			if [ "$i" = primary ]; then
3727c478bd9Sstevel@tonic-gate				primary=$1
3737c478bd9Sstevel@tonic-gate				break
3747c478bd9Sstevel@tonic-gate			fi
3757c478bd9Sstevel@tonic-gate		done
3767c478bd9Sstevel@tonic-gate
3777c478bd9Sstevel@tonic-gate		[ -n "$primary" ] && break
3787c478bd9Sstevel@tonic-gate		shift
3797c478bd9Sstevel@tonic-gate	done
3807c478bd9Sstevel@tonic-gate
3817c478bd9Sstevel@tonic-gate	[ -z "$primary" ] && primary="$firstif"
3827c478bd9Sstevel@tonic-gate	cmdline=`shcat /etc/dhcp\.${primary}`
3837c478bd9Sstevel@tonic-gate
3847c478bd9Sstevel@tonic-gate	if [ "$_INIT_NET_IF" != "$primary" ]; then
3857c478bd9Sstevel@tonic-gate		echo "starting DHCP on primary interface $primary"
3867c478bd9Sstevel@tonic-gate		/sbin/ifconfig $primary auto-dhcp primary $cmdline
3877c478bd9Sstevel@tonic-gate		# Exit code 4 means ifconfig timed out waiting for dhcpagent
3887c478bd9Sstevel@tonic-gate		[ $? != 0 ] && [ $? != 4 ] && i4d_fail="$i4d_fail $primary"
3897c478bd9Sstevel@tonic-gate	fi
3907c478bd9Sstevel@tonic-gate
3917c478bd9Sstevel@tonic-gate	set -- $interface_names
3927c478bd9Sstevel@tonic-gate
3937c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
3947c478bd9Sstevel@tonic-gate		shift
3957c478bd9Sstevel@tonic-gate		cmdline=`shcat /etc/dhcp\.$1`
3967c478bd9Sstevel@tonic-gate		if [ "$1" != "$primary" -a \
3977c478bd9Sstevel@tonic-gate			"$1" != "$_INIT_NET_IF"  ]; then
3987c478bd9Sstevel@tonic-gate			echo "starting DHCP on interface $1"
3997c478bd9Sstevel@tonic-gate			/sbin/ifconfig $1 dhcp start wait 0 $cmdline
4007c478bd9Sstevel@tonic-gate			# Exit code can't be timeout when wait is 0
4017c478bd9Sstevel@tonic-gate			[ $? != 0 ] && i4d_fail="$i4d_fail $1"
4027c478bd9Sstevel@tonic-gate		fi
4037c478bd9Sstevel@tonic-gate		shift
4047c478bd9Sstevel@tonic-gate	done
4057c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
4067c478bd9Sstevel@tonic-gate	unset ORIGIFS
407e11c3f44Smeem	[ -n "$i4d_fail" ] && warn_failed_ifs "configure IPv4 DHCP" "$i4d_fail"
4087c478bd9Sstevel@tonic-gatefi
4097c478bd9Sstevel@tonic-gate
4100659b2b8Sse146197# In order to avoid bringing up the interfaces that have
4110659b2b8Sse146197# intentionally been left down, perform RARP only if the system
4120659b2b8Sse146197# has no configured hostname in /etc/nodename
4130659b2b8Sse146197hostname="`shcat /etc/nodename 2>/dev/null`"
4140659b2b8Sse146197if [ "$_INIT_NET_STRATEGY" = "rarp" -o -z "$hostname" ]; then
4157c478bd9Sstevel@tonic-gate	/sbin/ifconfig -adD4 auto-revarp netmask + broadcast + up
4160659b2b8Sse146197fi
4177c478bd9Sstevel@tonic-gate
4187c478bd9Sstevel@tonic-gate#
4197c478bd9Sstevel@tonic-gate# If the /etc/defaultrouter file exists, process it now so that the next
4207c478bd9Sstevel@tonic-gate# stage of booting will have access to NFS.
4217c478bd9Sstevel@tonic-gate#
4227c478bd9Sstevel@tonic-gateif [ -f /etc/defaultrouter ]; then
4237c478bd9Sstevel@tonic-gate	while read router rubbish; do
4247c478bd9Sstevel@tonic-gate		case "$router" in
4257c478bd9Sstevel@tonic-gate			'#'* | '') ;;	#  Ignore comments, empty lines
4267c478bd9Sstevel@tonic-gate			*)	/sbin/route -n add default -gateway $router ;;
4277c478bd9Sstevel@tonic-gate		esac
4287c478bd9Sstevel@tonic-gate	done </etc/defaultrouter
4297c478bd9Sstevel@tonic-gatefi
4307c478bd9Sstevel@tonic-gate
4317c478bd9Sstevel@tonic-gate#
432843e1988Sjohnlev# If we get here and were not asked to plumb any IPv4 interfaces, look
433843e1988Sjohnlev# for boot properties that direct us.
434843e1988Sjohnlev#
435843e1988Sjohnlev# - The "network-interface" property is required and indicates the
436843e1988Sjohnlev#   interface name.
437843e1988Sjohnlev# - The "xpv-hcp" property, if present, is used by the hypervisor
438843e1988Sjohnlev#   tools to indicate how the specified interface should be configured.
439843e1988Sjohnlev#   Permitted values are "dhcp" and "off", where "off" indicates static
440843e1988Sjohnlev#   IP configuration.
441843e1988Sjohnlev#
442843e1988Sjohnlev# In the case where "xpv-hcp" is set to "dhcp", no further properties
443843e1988Sjohnlev# are required or examined.
444843e1988Sjohnlev#
445843e1988Sjohnlev# In the case where "xpv-hcp" is not present or set to "off", the
446843e1988Sjohnlev# "host-ip" and "subnet-mask" properties are used to configure
447843e1988Sjohnlev# the specified interface.  The "router-ip" property, if present,
448843e1988Sjohnlev# is used to add a default route.
449843e1988Sjohnlev#
450843e1988Sjohnlevnic="`/sbin/devprop network-interface`"
451843e1988Sjohnlevif smf_is_globalzone && [ -z "$inet_list" ] && [ -n "$nic" ]; then
452843e1988Sjohnlev	hcp="`/sbin/devprop xpv-hcp`"
453843e1988Sjohnlev	case "$hcp" in
454843e1988Sjohnlev	"dhcp")
455843e1988Sjohnlev		/sbin/ifconfig $nic plumb 2>/dev/null
456843e1988Sjohnlev		[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
457843e1988Sjohnlev			# The interface is successfully plumbed, so
458843e1988Sjohnlev			# modify "inet_list" to force the exit code
459843e1988Sjohnlev			# checks to work.
460843e1988Sjohnlev			inet_list=$nic;
461843e1988Sjohnlev			# Given that this is the only IPv4 interface,
462843e1988Sjohnlev			# we assert that it is primary.
463843e1988Sjohnlev			echo "starting DHCP on primary interface $primary";
464843e1988Sjohnlev			/sbin/ifconfig $nic auto-dhcp primary;
465843e1988Sjohnlev			# Exit code 4 means ifconfig timed out waiting
466843e1988Sjohnlev			# for dhcpagent
467843e1988Sjohnlev			[ $? != 0 ] && [ $? != 4 ] && \
468843e1988Sjohnlev			    i4d_fail="$i4d_fail $nic";
469843e1988Sjohnlev		)
470843e1988Sjohnlev		;;
471843e1988Sjohnlev
472843e1988Sjohnlev	"off"|"")
473843e1988Sjohnlev		/sbin/devprop host-ip subnet-mask router-ip | (
474843e1988Sjohnlev			read ip;
475843e1988Sjohnlev			read mask;
476843e1988Sjohnlev			read router;
477843e1988Sjohnlev			[ -n "$ip" ] && [ -n "$mask" ] && \
478843e1988Sjohnlev				/sbin/ifconfig $nic plumb 2>/dev/null
479843e1988Sjohnlev			[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
480843e1988Sjohnlev				# The interface is successfully
481843e1988Sjohnlev				# plumbed, so modify "inet_list" to
482843e1988Sjohnlev				# force the exit code checks to work.
483843e1988Sjohnlev				inet_list=$nic;
484843e1988Sjohnlev				/sbin/ifconfig $nic  inet $ip \
485843e1988Sjohnlev				    netmask $mask broadcast + up 2>/dev/null;
486843e1988Sjohnlev				[ -n "$router" ] && route add \
487843e1988Sjohnlev				    default $router 2>/dev/null;
488843e1988Sjohnlev			)
489843e1988Sjohnlev		)
490843e1988Sjohnlev		;;
491843e1988Sjohnlev	esac
492843e1988Sjohnlevfi
493843e1988Sjohnlev
494843e1988Sjohnlev#
4957c478bd9Sstevel@tonic-gate# We tell smf this service is online if any of the following is true:
4967c478bd9Sstevel@tonic-gate# - no interfaces were configured for plumbing and no DHCP failures
4977c478bd9Sstevel@tonic-gate# - any non-loopback IPv4 interfaces are up and have a non-zero address
4987c478bd9Sstevel@tonic-gate# - there are any DHCP interfaces started
4997c478bd9Sstevel@tonic-gate# - any non-loopback IPv6 interfaces are up
5007c478bd9Sstevel@tonic-gate#
5017c478bd9Sstevel@tonic-gate# If we weren't asked to configure any interfaces, exit
5027c478bd9Sstevel@tonic-gateif [ -z "$inet_list" ] && [ -z "$inet6_list" ]; then
5037c478bd9Sstevel@tonic-gate	# Config error if DHCP was attempted without plumbed interfaces
5047c478bd9Sstevel@tonic-gate	[ -n "$i4d_fail" ] && exit $SMF_EXIT_ERR_CONFIG
5057c478bd9Sstevel@tonic-gate	exit $SMF_EXIT_OK
5067c478bd9Sstevel@tonic-gatefi
5077c478bd9Sstevel@tonic-gate
5087c478bd9Sstevel@tonic-gate# Any non-loopback IPv4 interfaces with usable addresses up?
5097c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -a4u`" ]; then
5107c478bd9Sstevel@tonic-gate    	/sbin/ifconfig -a4u | while read intf addr rest; do
5117c478bd9Sstevel@tonic-gate		[ $intf = inet ] && [ $addr != 127.0.0.1 ] &&
512843e1988Sjohnlev		[ $addr != 0.0.0.0 ] && exit $SMF_EXIT_OK
5137c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
5147c478bd9Sstevel@tonic-gatefi
5157c478bd9Sstevel@tonic-gate
5167c478bd9Sstevel@tonic-gate# Any DHCP interfaces started?
5177c478bd9Sstevel@tonic-gate[ -n "`/sbin/ifconfig -a4 dhcp status 2>/dev/null`" ] && exit $SMF_EXIT_OK
5187c478bd9Sstevel@tonic-gate
5197c478bd9Sstevel@tonic-gate# Any non-loopback IPv6 interfaces up?
5207c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -au6`" ]; then
5217c478bd9Sstevel@tonic-gate	/sbin/ifconfig -au6 | while read intf addr rest; do
522843e1988Sjohnlev		[ $intf = inet6 ] && [ $addr != ::1/128 ] && exit $SMF_EXIT_OK
5237c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
5247c478bd9Sstevel@tonic-gatefi
5257c478bd9Sstevel@tonic-gate
5267c478bd9Sstevel@tonic-gate# This service was supposed to configure something yet didn't.  Exit
5277c478bd9Sstevel@tonic-gate# with config error.
5287c478bd9Sstevel@tonic-gateexit $SMF_EXIT_ERR_CONFIG
529